/**
 * Created by Administrator on 2014/12/4.
 */

var _bulletArr;
var _enemy1BulletSpeed = 4;
var _enemy1BulletArr;
var _bulletType = 1;

function Bullet() {
    base(this, LSprite, []);

    var self = this;

    self.bitmapData = new LBitmapData(_imgList["bullet"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
    //self.testCount = 0;
    //self.shootDistance = 5;
    self.shootCount = 0;
    self.enemy1XSpeed = 0;
    self.enemy1YSpeed = 0;
    self.shotXSpeed = 0;
    self.shotYSpeed = 0;
}

Bullet.prototype.onframe = function (whichBullet) {
    var self = this;
        if(self.x < 0 || self.x > LGlobal.width || self.y < 0 || self.y > LGlobal.height) {
            _enermyBulletLayer.removeChild(self);
            _enemy1BulletArr.splice(whichBullet, 1);
        }

    self.x += self.enemy1XSpeed;
    self.y += self.enemy1YSpeed;

}

function ShotBullet() {
    base(this, Bullet, []);
}

ShotBullet.prototype.onframe = function (whichBullet) {
    var self = this;
    if(_bulletType == 2) {
        self.x += self.shotXSpeed;
        self.y += self.shotYSpeed;
        if(self.shootCount == _shootDistance) {
            _bulletLayer.removeChild(self);
            _bulletArr.splice(whichBullet, 1);
        }
        self.shootCount++;
    }
}

function DoubleBullet() {
    base(this, Bullet, []);
}

DoubleBullet.prototype.onframe = function (whichBullet) {
    var self = this;
    if(_bulletType == 3) {
        self.x -= 3 * _bulletSpeed * (_shootButtonCenterX - _shootButton.bitmap.x) / _shootSlideDistance;
        self.y -= 4 * _bulletSpeed;
        if(self.shootCount == _shootDistance) {
            _bulletLayer.removeChild(self);
            _bulletArr.splice(whichBullet, 1);
        }
        self.shootCount++;
    }
}

function Boss1Bullet() {
    base(this, Bullet, []);

    var self = this;
}

Boss1Bullet.prototype.onframe = function (whichBullet) {
    var self = this;

    self.x += self.enemy1XSpeed;
    self.y += self.enemy1YSpeed;

    if(self.x < 0 || self.x > LGlobal.width || self.y < 0 || self.y > LGlobal.height) {
        _enermyBulletLayer.removeChild(self);
        _enemy1BulletArr.splice(whichBullet, 1);
    }
}

function SectorBullet() {
    base(this, LSprite, []);
    var self = this;

    var list = LGlobal.divideCoordinate(1012, 181, 1, 4);
    var data = new LBitmapData(_imgList["sector"], 0, 0, 253, 181);
    self.animeRun = new LAnimation(self, data, [
        [list[0][0], list[0][1], list[0][2], list[0][3]]
    ]);
    //self.bitmapData = new LBitmapData(_imgList["sector"]);
    //self.bitmap = new LBitmap(self.bitmapData);
    //self.addChild(self.bitmap);

    self.existCount = 0;
    self.existInterval = 3;
}

SectorBullet.prototype.onframe = function (whichBullet) {
    var self = this;

    self.animeRun.onframe();
    for(var i = 0; i < _enemy1Arr.length; i++) {
        if(sectorHitEnemy(_enemy1Arr[i], _player) == true) {
            _enemy1Layer.removeChild(_enemy1Arr[i]);
            _enemy1Arr.splice(i, 1);
            _mark += 100;
            _killEnemyCount++;
        }
    }

    for(var i = 0; i < _enemy2Arr.length; i++) {
        if(sectorHitEnemy(_enemy2Arr[i], _player) == true) {
            var explodeX = _enemy2Arr[i].x + 16 - 27;
            var explodeY = _enemy2Arr[i].y + 24 - 27;
            _enemy2Layer.removeChild(_enemy2Arr[i]);
            _enemy2Arr.splice(i, 1);
            var explode = new Explode();
            explode.x = explodeX;
            explode.y = explodeY;
            _background.addChild(explode);
            _explodeArr.push(explode);
            _mark += 100;
            _killEnemyCount++;
        }
    }

    for(var i = 0; i < _enemy3Arr.length; i++) {
        if(sectorHitEnemy(_enemy3Arr[i], _player) == true) {
            _enemy3Layer.removeChild(_enemy3Arr[i]);
            _enemy3Arr.splice(i, 1);
            _mark += 100;
            _killEnemyCount++;
        }
    }

    for(var i = 0; i < _thingArr.length; i++) {
        if(sectorHitEnemy(_thingArr[i], _player) == true) {
            _thingArr[i].hp -= 1;
            //_thingManager.removeChild(_thingArr[i]);
            //_thingArr.splice(i, 1);
            if(_thingArr[i].hp <= 0) {
                var thing = _thingArr[i];
                _thingManager.removeChild(_thingArr[i]);
                _thingArr.splice(i, 1);
                var thingX = thing.x;
                var thingY = thing.y;
                var whichType = Math.floor(1 + 6 * Math.random());
                initThing(whichType, thingX, thingY);
            }

        }
    }

    if(_boss1 != null) {
        if(_boss1.canHited == true && sectorHitEnemy(_boss1, _player) == true) {
            _boss1.hp -= 1 / 3;
            if(_boss1.hp <= 0) {
                _backLayer.removeChild(self);
                _boss1 = null;
            }
        }
    }

    if(self.existCount == self.existInterval) {
        _sectorLayer.removeChild(self);
        _sectorArr.splice(whichBullet, 1);
    }
    self.existCount++;
}

function sectorHitEnemy(enemy, player) {
    var enemyX = enemy.x + 16;
    var enemyY = enemy.y + 24;
    var playerX = player.x + 16;
    var playerY = player.y + 24;

    var radius = Math.sqrt((enemyX - playerX) * (enemyX - playerX) + (enemyY - playerY) * (enemyY - playerY));
    var sin = (playerY - enemyY) / radius;

    if(radius <= 180 && sin >= Math.sqrt(2) / 2) {
        return true;
    } else {
        return false;
    }
}