/**
 * Created by Administrator on 2014/12/4.
 */

var _isMoveTouchDown;
var _moveCenterX;
var _moveCenterY;
var _radius;
var _borderRadius;
var _squareX;
var _squareY;
var _moveInitX;
var _moveInitY;
var _moveSpeed;

function MoveButton() {
    base(this, LSprite, []);
    _isMoveTouchDown = false;
    _moveSpeed = 6;
    var self = this;

    self.borderBitmapData = new LBitmapData(_imgList["moveBorder"]);
    self.borderBitmap = new LBitmap(self.borderBitmapData);
    self.addChild(self.borderBitmap);

    self.bitmapData = new LBitmapData(_imgList["moveButton"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);

    self.bitmap.x = LGlobal.width / 8;
    self.bitmap.y = LGlobal.height / 4 * 3;
    _moveInitX = self.bitmap.x;
    _moveInitY = self.bitmap.y;

    _moveCenterX = self.bitmap.x + self.bitmap.width / 2;
    _moveCenterY = self.bitmap.y + self.bitmap.height / 2;
    _radius = self.bitmap.width / 2;
    self.borderBitmap.x = _moveCenterX - self.borderBitmap.width / 2;
    self.borderBitmap.y = _moveCenterY - self.borderBitmap.height / 2;
    _borderRadius = self.borderBitmap.width / 2;
    _squareX = 0;
    _squareY = 0;

    self.addEventListener(LMouseEvent.MOUSE_DOWN, moveDown);
    self.addEventListener(LMouseEvent.MOUSE_MOVE, moveMove);
    self.addEventListener(LMouseEvent.MOUSE_UP, moveUp);
}

function moveDown(event) {
    _isMoveTouchDown = true;
}

function moveMove(event) {
    var thisX = event.offsetX;
    var thisY = event.offsetY;
    var ifInMoveButton = isInMoveButton(thisX, thisY);

    if(_isMoveTouchDown == true && ifInMoveButton == true) {
        _moveButton.bitmap.x = thisX - _radius;
        _moveButton.bitmap.y = thisY - _radius;
        _playerMoveX = (thisX - _moveCenterX) / Math.sqrt(_squareX + _squareY) * _moveSpeed;
        _playerMoveY = (thisY - _moveCenterY) / Math.sqrt(_squareX + _squareY) * _moveSpeed;
        _collideX = _playerMoveX;
        _collideY = _playerMoveY;

    }

    if(_isMoveTouchDown == true && ifInMoveButton == false) {
        var squareX = (thisX - _moveCenterX) * (thisX - _moveCenterX);
        var squareY = (thisY - _moveCenterY) * (thisY - _moveCenterY);
        var radius = Math.sqrt(squareX + squareY);
        _moveButton.bitmap.x = (thisX - _moveCenterX) / radius * (_radius + 60) + _moveInitX;
        _moveButton.bitmap.y = (thisY - _moveCenterY) / radius * (_radius + 60) + _moveInitY;
        _playerMoveX = (thisX - _moveCenterX) / Math.sqrt(_squareX + _squareY) * _moveSpeed;
        _playerMoveY = (thisY - _moveCenterY) / Math.sqrt(_squareX + _squareY) * _moveSpeed;
        _collideX = _playerMoveX;
        _collideY = _playerMoveY;
    }

}

function moveUp(event) {
    _isMoveTouchDown = false;
    _moveButton.bitmap.x = _moveInitX;
    _moveButton.bitmap.y = _moveInitY;
    _playerMoveX = 0;
    _playerMoveY = 0;
}

function isInMoveButton(thisX, thisY) {


    _squareX = (thisX - _moveCenterX) * (thisX - _moveCenterX);
    _squareY = (thisY - _moveCenterY) * (thisY - _moveCenterY);
    _squareRadius = (_radius + 60) * (_radius + 60);
    if(_squareX + _squareY <= _squareRadius) {
        return true;
    } else {
        return false;
    }
}