/**
 * Created by Administrator on 2014/12/10.
 */

var _store;

var _thingArr;

var _initBarrelCount = 400;
var _initBarrelInterval = 500;

var _horseAni = null;
var _isBuyHorse = false;

function ThingManager() {
    base(this, LSprite, []);

    var self = this;
    self.initStoreCount = 1950;
    self.initStoreInterval = 2000;
}

ThingManager.prototype.onframe = function() {
    var self = this;

    if(_initBarrelCount == _initBarrelInterval) {
        _initBarrelCount = 0;
        var barrel = new Barrel();
        barrel.x = Math.floor(20 + 420 * Math.random());
        barrel.y = - 48;
        _thingManager.addChild(barrel);
        _thingArr.push(barrel);
    }
    _initBarrelCount++;

    for(var i = 0; i < _thingArr.length; i++) {
        _thingArr[i].onframe(i);
    }

    if(self.initStoreCount == self.initStoreInterval) {
        self.initStoreCount = 0;
        var mapStore = new MapStore();
        mapStore.x = 100;
        mapStore.y = -60;
        _thingManager.addChild(mapStore);
        _thingArr.push(mapStore);
    }
    self.initStoreCount++;
}

function isGetThing(thing, player) {
    var centerX = player.x + 16;
    var centerY = player.y + 24;

    if(centerX > thing.x - 5 && centerX < thing.x + thing.bitmap.width + 5 && centerY > thing.y - 5&& centerY < thing.y + thing.bitmap.height + 5) {
        return true;
    } else {
        return false;
    }
}

function Barrel() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["barrel"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);

    self.hp = 5;
}

Barrel.prototype.onframe = function (whichBarrel) {
    var self = this;

    for(var i = 0; i < _bulletArr.length; i++) {

        if(hitEnermy(self, _bulletArr[i])) {
            _bulletLayer.removeChild(_bulletArr[i]);
            _bulletArr.splice(i, 1);
            self.hp--;
            var spark = new Spark();
            spark.x = self.x;
            spark.y = self.y;
            _thingManager.addChild(spark);
            _thingArr.push(spark);
//          _woodWav.play();
        }
    }

    if(self.hp <= 0) {
        var thingX = self.x;
        var thingY = self.y;
        _thingManager.removeChild(self);
        _thingArr.splice(whichBarrel, 1);
        var random = Math.random() * 100;
        var whichType;
        if(random < 8) {
            whichType = 1;
        }
        if(random < 28 && random >= 8) {
            whichType = 2;
        }
        if(random < 38 && random >= 28) {
            whichType = 3;
        }
        if(random < 53 && random >= 38) {
            whichType = 4;
        }
        if(random < 63 && random >= 53) {
            whichType = 5;
        }
        if(random < 68 && random >= 63) {
            whichType = 6;
        }
        if(random < 70 && random >= 68) {
            whichType = 7;
        }
        if(random < 100 && random >= 70) {
            whichType = 8;
        }
        //whichType = 3;
        initThing(whichType, thingX, thingY);
    }

    self.y ++;
}

function initThing(whichType, thingX, thingY) {
    var thing;
    if(whichType == 1) {
        thing = new Horse();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 2) {
        thing = new Gun();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 3) {
        thing = new Bomb();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 4) {
        thing = new Revolver();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 5) {
        thing = new DoubleRevolver();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 6) {
        thing = new ShotGun();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 7) {
        thing = new Wanted();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    if(whichType == 8) {
        thing = new Money();
        _thingManager.addChild(thing);
        _thingArr.push(thing);
    }

    thing.x = thingX;
    thing.y = thingY;
}

function Horse() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["horse"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

Horse.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        if(_moveSpeed != 8) {
            _thingManager.removeChild(self);
            _thingArr.splice(index, 1);
            _moveSpeed = 8;
            _isPause = true;
            _horseAni = new HorseAnime();
            _horseAni.x = _player.x;
            _horseAni.y = LGlobal.height;
            _background.addChild(_horseAni);
        }

        if(_moveSpeed == 8) {
            _thingManager.removeChild(self);
            _thingArr.splice(index, 1);
            _mark += 2000;
        }

    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function Gun() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["gun"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

Gun.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _shootDistance += 2;
        if(_shootDistance >= 18) {
            _shootDistance = 18;
        }
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function Bomb() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["bomb"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

Bomb.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);

        _enemy1Layer.removeAllChild();
        _enermyBulletLayer.removeAllChild();
        _enemy1Arr.splice(0);
        _enemy1BulletArr.splice(0);
        _enemy2Layer.removeAllChild();
        _enemy2Arr.splice(0);
        _enemy3Layer.removeAllChild();
        _enemy3Arr.splice(0);
        _mark += 2000;
//      _bombWav.play();
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function Revolver() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["revolver"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

Revolver.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _player.count = 3;
        _bulletType = 1;
        _bulletLayer.removeAllChild();
        _bulletArr.splice(0);
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function DoubleRevolver() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["double_revolver"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

DoubleRevolver.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _player.count = 3;
        _bulletType = 3;
        _bulletLayer.removeAllChild();
        _bulletArr.splice(0);
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function ShotGun() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["shotgun"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

ShotGun.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _player.count = 15;
        _bulletType = 2;
        _bulletLayer.removeAllChild();
        _bulletArr.splice(0);
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function Wanted() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["wanted"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

Wanted.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _isInitBoss = true;
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function Money() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["money"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

Money.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _mark += 1000;
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function MapStore() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["store"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
}

MapStore.prototype.onframe = function (index) {
    var self = this;
    if(isGetThing(self, _player) == true) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
        _store = new Store();
        _backLayer.addChild(_store);
        _isPause = true;
    }
    if(self.y > LGlobal.height) {
        _thingManager.removeChild(self);
        _thingArr.splice(index, 1);
    }
    self.y++;
}

function Spark() {
    base(this, LSprite, []);
    var self = this;
    self.bitmapData = new LBitmapData(_imgList["spark"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap);
    self.count = 0;
}

Spark.prototype.onframe = function (whichSpark) {

    var self = this;

    if(self.count == 2) {
        _thingManager.removeChild(self);
        _thingArr.splice(whichSpark, 1);
    }
    self.count++;
}